      SUBROUTINE VOIGT(A,VS,H)
C
C  COMPUTES A VOIGT FUNCTION  H = H(A,V)
C  A=GAMMA/(4*PI*DNUD)   AND  V=(NU-NU0)/DNUD.  THIS  IS  DONE AFTER
C  TRAVING (LANDOLT-B\RNSTEIN, P. 449).
C
C  CODED BY: KJELL ERIKSSON  (APR-1974). REVISED: (JULY-1975).
C
      DIMENSION AK(19),A1(5)
      DATA AK      /-1.12470432, -0.15516677,  3.28867591, -2.34357915,
     ,  0.42139162, -4.48480194,  9.39456063, -6.61487486,  1.98919585,
     , -0.22041650, 0.554153432, 0.278711796,-0.188325687, 0.042991293,
     ,-0.003278278, 0.979895023,-0.962846325, 0.532770573,-0.122727278/
      DATA SQP/1.772453851/,SQ2/1.414213562/
C
      V = ABS(VS)
      U = A + V
      V2 = V*V
      IF (A.EQ.0.0) GO TO 140
      IF (A.GT.0.2) GO TO 120
      IF (V.GE.5.0) GO TO 121
C
      EX=0.
      IF(V2.LT.100.)EX = EXP(-V2)
      K = 1
C
  100 QUO = 1.
      IF (V.LT.2.4) GO TO 101
      QUO = 1./(V2 - 1.5)
      M = 11
      GO TO 102
C
  101 M = 6
      IF (V.LT.1.3) M = 1
  102 DO 103 I=1,5
         A1(I) = AK(M)
         M = M + 1
  103 CONTINUE
      H1 = QUO*(A1(1) + V*(A1(2) + V*(A1(3) + V*(A1(4) + V*A1(5)))))
      IF (K.GT.1) GO TO 110
C
C A LE 0.2  AND V LT 5.
C
      H = H1*A + EX*(1. + A*A*(1. - 2.*V2))
      RETURN
C
  110 PQS = 2./SQP
      H1P = H1 + PQS*EX
      H2P = PQS*H1P - 2.*V2*EX
      H3P = (PQS*(1. - EX*(1. - 2.*V2)) - 2.*V2*H1P)/3. + PQS*H2P
      H4P = (2.*V2*V2*EX - PQS*H1P)/3. + PQS*H3P
      PSI = AK(16) + A*(AK(17) + A*(AK(18) + A*AK(19)))
C
C 0.2 LT A LE 1.4  AND  A + V LE 3.2
C
      H = PSI*(EX + A*(H1P + A*(H2P + A*(H3P + A*H4P))))
      RETURN
C
  120 IF (A.GT.1.4.OR.U.GT.3.2) GO TO 130
      EX=0.
      IF(V2.LT.100.)EX = EXP(-V2)
      K = 2
      GO TO 100
C
C A LE 0.2  AND  V GE 5.
C
  121 H = A*(15. + 6.*V2 + 4.*V2*V2)/(4.*V2*V2*V2*SQP)
      RETURN
C
  130 A2 = A*A
      U = SQ2*(A2 + V2)
      U2 = 1./(U*U)
C
C A GT 1.4  OR  A + V GT 3.2
C
      H = SQ2/SQP*A/U*(1. + U2*(3.*V2 - A2) +
     ,        U2*U2*(15.*V2*V2 - 30.*V2*A2 + 3.*A2*A2))
      RETURN
C
C A EQ 0.
C
  140 H=0.
      IF(V2.LT.100.)H=EXP(-V2)
      RETURN
      END
C
C********************************************************************
C
